%define WITH_SELINUX 0

# disable for RHEL
%define thread_badhack 1

Summary: System and process monitoring utilities.
Name: procps
Version: 2.0.17
Release: 13.10
License: GPL
Group: Applications/System
Source: http://www.surriel.com/procps/procps-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Prereq: /bin/rm /sbin/ldconfig
Patch1: procps-2.0.17-nptl-nobadhack.patch
Patch2: procps-2.0.13-thread-badhack.patch
Patch3: procps-2.0.17-timing.patch
Patch4: procps-2.0.17-slabtop.patch
Patch5: procps-2.0.17-cpus.patch
Patch6: procps-2.0.17-maxcmds.patch
Patch7: procps-2.0.17-noirixmode.patch
Patch8: procps-2.0.17-showthr.patch
Patch9: procps-2.0.17-skipthreads.patch
Patch10: procps-2.0.17-uint.patch
Patch11: procps-2.0.17-longcmd.patch
Patch12: procps-2.0.17-continue.patch
Patch13: procps-2.0.17-vmzero.patch
Patch14: procps-2.0.17-bo.patch
Patch15: procps-2.0.17-cmdsel.patch
Patch16: procps-2.0.17-badtype.patch
Patch17: procps-2.0.17-order.patch
Patch18: procps-2.0.17-slab-int2long.patch
# 167802 - CRM648268: top process time reporting proble
Patch19: procps-2.0.17-top-timeint.patch
# 177453 - top (size) vs. ps (vsize) vs. /proc/$pid/status (VmSize)
Patch20: procps-2.0.17-top-vmsize-env.patch
# 178059 - [RHEL3] ps -aucx reports bogus %CPU for mt app
Patch21: procps-2.0.17-ps-pcpu.patch

BuildRequires: ncurses-devel

%description
The procps package contains a set of system utilities that provide
system information. Procps includes ps, free, skill, snice, tload,
top, uptime, vmstat, w, and watch. The ps command displays a snapshot
of running processes. The top command provides a repetitive update of
the statuses of running processes. The free command displays the
amounts of free and used memory on your system. The skill command
sends a terminate command (or another specified signal) to a specified
set of processes. The snice command is used to change the scheduling
priority of specified processes. The tload command prints a graph of
the current system load average to a specified tty. The uptime command
displays the current time, how long the system has been running, how
many users are logged on, and system load averages for the past one,
five, and fifteen minutes. The w command displays a list of the users
who are currently logged on and what they are running. The watch
program watches a running program. The vmstat command displays virtual
memory statistics about processes, memory, paging, block I/O, traps,
and CPU activity.

%prep
%setup -q
%patch1 -p1 -b .nptl
%if %{thread_badhack}
%patch2 -p1 -b .threadbadhack
%endif
%patch3 -p1 -b .timing
%patch4 -p1 -b .slabtop
%patch5 -p1 -b .cpus
%patch6 -p1 -b .maxcmds
%patch7 -p1 -b .noirixmode
%patch8 -p1 -b .showthr
%patch9 -p1 -b .skipthreads
%patch10 -p1 -b .uint
%patch11 -p1 -b .longcmd
%patch12 -p1 -b .continue
%patch13 -p1 -b .vmzero
%patch14 -p1 -b .bo
%patch15 -p1 -b .cmdsel
%patch16 -p1 -b .badtype
%patch17 -p1 -b .order
%patch18 -p1 -b .int2long
%patch19 -p1 -b .timeint
%patch20 -p1 -b .top-vmsize-env
%patch21 -p1 -b .pcpu

%build
PATH=/usr/X11R6/bin:$PATH

make CC="gcc $RPM_OPT_FLAGS" MANDIR=%{_mandir}

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/bin %{buildroot}/usr/bin %{buildroot}/sbin
mkdir -p %{buildroot}%{_mandir}/{man1,man5,man8}
mkdir -p %{buildroot}/%{_lib} %{buildroot}/usr/X11R6/bin
mkdir -p %{buildroot}/etc/X11/applnk/Utilities

make DESTDIR=%{buildroot} SHLIBDIR=%{buildroot}/%{_lib} OWNERGROUP= MANDIR=%{_mandir} install

# Remove unpackaged files:

%clean
rm -rf %{buildroot}

%post
# add libproc to the cache
/sbin/ldconfig
# remove obsolete files
rm -f /etc/psdevtab /etc/psdatabase

%postun -p /sbin/ldconfig

%files
%defattr(0644,root,root,755)
%doc NEWS BUGS TODO
%attr(755,root,root) /%{_lib}/libproc.so.2.0.17
%attr(555,root,root) /bin/ps
%attr(555,root,root) /sbin/sysctl
%attr(555,root,root) /usr/bin/uptime
%attr(555,root,root) /usr/bin/tload
%attr(555,root,root) /usr/bin/free
%attr(555,root,root) /usr/bin/w
%attr(555,root,root) /usr/bin/top
%attr(555,root,root) /usr/bin/vmstat
%attr(555,root,root) /usr/bin/watch
%attr(555,root,root) /usr/bin/skill
%attr(555,root,root) /usr/bin/snice
%attr(555,root,root) /usr/bin/pgrep
%attr(555,root,root) /usr/bin/pkill
%attr(555,root,root) /usr/bin/pmap
%attr(555,root,root) /usr/bin/slabtop

%attr(0644,root,root) %{_mandir}/man1/free.1*
%attr(0644,root,root) %{_mandir}/man1/ps.1*
%attr(0644,root,root) %{_mandir}/man1/skill.1*
%attr(0644,root,root) %{_mandir}/man1/snice.1*
%attr(0644,root,root) %{_mandir}/man1/pgrep.1*
%attr(0644,root,root) %{_mandir}/man1/pkill.1*
%attr(0644,root,root) %{_mandir}/man1/pmap.1*
%attr(0644,root,root) %{_mandir}/man1/slabtop.1*
%attr(0644,root,root) %{_mandir}/man1/tload.1*
%attr(0644,root,root) %{_mandir}/man1/top.1*
%attr(0644,root,root) %{_mandir}/man1/uptime.1*
%attr(0644,root,root) %{_mandir}/man1/w.1*
%attr(0644,root,root) %{_mandir}/man1/watch.1*
%attr(0644,root,root) %{_mandir}/man8/vmstat.8*
%attr(0644,root,root) %{_mandir}/man8/sysctl.8*
%attr(0644,root,root) %{_mandir}/man5/sysctl.conf.5*

%changelog
* Wed Apr  5 2006 Karel Zak <kzak@redhat.com> 2.0.17-13.10
- fix #178059 - ps -aucx reports bogus %CPU for mt app

* Wed Feb  8 2006 Karel Zak <kzak@redhat.com> 2.0.17-13.9
- fix #167802 - top process time reporting problem
- fix #177453 - top (size) vs. ps (vsize) vs. /proc/$pid/status (VmSize)

* Tue Jul 19 2005 Karel Zak <kzak@redhat.com> 2.0.17-13.8
- fix #155883 - RHEL3: slabtop calculation overflow

* Wed Apr 20 2005 Karel Zak <kzak@redhat.com> 2.0.17-13.7
- fixed procps-2.0.17-order.patch

* Wed Feb  2 2005 Karel Zak <kzak@redhat.com> 2.0.17-13.6
- fixed top man page that offered unsupported switch "-H" (#138187)
- fixed order of vmstat columns (#146695)

* Tue Jan  4 2005 Karel Zak <kzak@redhat.com> 2.0.17-13.5
- fixed problem with big UIDs in ps (#143989)

* Tue Dec  7 2004 Karel Zak <kzak@redhat.com> 2.0.17-13.4
- enlarged buffer that is used for -C option to 16 bytes (#143838)

* Tue Dec  7 2004 Karel Zak <kzak@redhat.com> 2.0.17-13.3
- fixed error in vmstat manpage (bi vs. bo column) (#137414)

* Wed Dec  1 2004 Karel Zak <kzak@redhat.com> 2.0.17-13.2
- zeroize vm_ stuff if loading from statm or status failed (#140409)

* Tue Nov 23 2004 Karel Zak <kzak@redhat.com> 2.0.17-13.1
- vmstat dies parsing /proc/stats (#109147)

* Wed Nov 03 2004 Karel Zak <kzak@redhat.com> 2.0.17-13
- fix ps truncates line to 2048 characters (#134516)

* Mon Oct 05 2004 Karel Zak <kzak@redhat.com> 2.0.17-12E.2
- fix percentages in top are display (#132091)

* Mon Oct 04 2004 Jindrich Novy <jnovy@redhat.com> 2.0.17-12E.1
- added .1 for the correct build

* Wed Sep 29 2004 Jindrich Novy <jnovy@redhat.com> 2.0.17-12E
- added patch by Bernd Schmidt to not to send signals to threads (#124690)

* Fri Sep 24 2004 Jindrich Novy <jnovy@redhat.com> 2.0.17-11E
- enabled showing threads by default in top (#130027)

* Thu Sep 16 2004 Dan Walsh <dwalsh@redhat.com> 2.0.17-11
- Readd noirixmode patch

* Tue Jun 29 2004 Phil Knirsch <pknirsch@redhat.com> 2.0.17-10
- Added fix to avoids an out-of-bounds array access (#118148)

* Thu Jun 24 2004 Dan Walsh <dwalsh@redhat.com> 2.0.17-9
- add multi-cpus patch

* Mon Jun 14 2004 Dan Walsh <dwalsh@redhat.com> 2.0.17-8
- Remove SELinux patch and add slaptop patch from 3.2.1

* Tue Jan 20 2004 Dan Walsh <dwalsh@redhat.com> 2.0.17-7
- Remove LIBCURSES from skill and sysctl

* Wed Dec  10 2003 Dan Walsh <dwalsh@redhat.com> 2.0.17-6
- Turn on SELinux

* Mon Dec  8 2003 Alexander Larsson <alexl@redhat.com> 2.0.17-5
- Fix top total percentages (#109484)

* Wed Oct 15 2003 Dan Walsh <dwalsh@redhat.com> 2.0.17-4
- Turn off selinux

* Wed Oct 15 2003 Dan Walsh <dwalsh@redhat.com> 2.0.17-3.sel
- Fix help message

* Thu Oct 9 2003 Dan Walsh <dwalsh@redhat.com> 2.0.17-2.sel
- Turn on selinux

* Fri Oct  3 2003 Alexander Larsson <alexl@redhat.com> 2.0.17-1
- Update to 2.0.17, drop upstream patches, forward port remaining patches

* Fri Sep 5 2003 Dan Walsh <dwalsh@redhat.com> 2.0.13-11
- Turn off selinux

* Thu Aug 28 2003 Dan Walsh <dwalsh@redhat.com> 2.0.13-10.sel
- Add -Z switch for SELinux

* Sun Aug 17 2003 Doug Ledford <dledford@redhat.com> 2.0.13-9E
- Add patch to recognize irq and softirq time accounting in kernels that
  support this feature

* Mon Aug 11 2003 Alexander Larsson <alexl@redhat.com> 2.0.13-8
- rebuild

* Mon Aug 11 2003 Alexander Larsson <alexl@redhat.com> 2.0.13-7E
- Add swapped patch from rik van riel

* Wed Aug  6 2003 Alexander Larsson <alexl@redhat.com> 2.0.13-6
- rebuild

* Wed Aug  6 2003 Alexander Larsson <alexl@redhat.com> 2.0.13-5E
- Update iowait patch (#101657)
- Add wchan 64bit patch from Mark DeWandel

* Mon Jul 28 2003 Dan Walsh <dwalsh@redhat.com> 2.0.13-4E
- Add SELinux patch

* Wed Jul 16 2003 Matt Wilson <msw@redhat.com> 2.0.13-3E
- display iowait with procps-2.0.13-iowait.patch (#99061)

* Fri Jul 11 2003 Alexander Larsson <alexl@redhat.com> 2.0.13-2E
- Disable linuxthreads thread hack

* Mon Jul  7 2003 Alexander Larsson <alexl@redhat.com> 2.0.13-1E
- rebuild

* Fri Jul  4 2003 Alexander Larsson <alexl@redhat.com> 2.0.13-1
- update to 2.0.13
- Re-merged ntpl patch
- Add hertz fix from Ernie Petrides <petrides@redhat.com>

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri May 23 2003 Alexander Larsson <alexl@redhat.com> 2.0.12-1
- Update to 2.0.12
- Add patch to fix segfault on ps axl (#91453)

* Fri Mar 14 2003 Alexander Larsson <alexl@redhat.com> 2.0.11-7
- Add patch that fixes negative priorities in top.

* Thu Feb 20 2003 Alexander Larsson <alexl@redhat.com> 2.0.11-6
- New NPTL patch:
- Added skipthreads optimization to top
- Don't read threads in 'w'

* Thu Feb 20 2003 Alexander Larsson <alexl@redhat.com> 2.0.11-5
- Update the NPTL patch since the kernel /proc was fixed
- For kernels >= 2.4.20-2.50

* Mon Feb 17 2003 Alexander Larsson <alexl@redhat.com> 2.0.11-4
- Update nptl patch to new /proc layout. 

* Wed Jan 22 2003 Tim Powers <timp@redhat.com> 2.0.11-3
- rebuilt

* Wed Jan 22 2003 Alexander Larsson <alexl@redhat.com> 2.0.11-2
- Created nptl patch after discussion with ingo and arjan

* Tue Jan 21 2003 Alexander Larsson <alexl@redhat.com> 2.0.11-1
- Update to 2.0.11

* Mon Dec 16 2002 Elliot Lee <sopwith@redhat.com> 2.0.10-4
- Fix %%install in changelog

* Tue Nov 19 2002 Jakub Jelinek <jakub@redhat.com> 2.0.10-3
- Fix for Hammer

* Wed Oct 23 2002 Alexander Larsson <alexl@redhat.com> 2.0.10-2
- Remove uninstalled files in %%install. Add pmap to %%files

* Tue Oct  8 2002 Alexander Larsson <alexl@redhat.com> 2.0.10-1
- Update to 2.0.10
- Removed applied patches.

* Mon Aug 12 2002 Alexander Larsson <alexl@redhat.com> 2.0.7-25
- Add patch to protect against idle ticks going backwards. Fixes #71237

* Thu Aug  8 2002 Alexander Larsson <alexl@redhat.com> 2.0.7-24
- Fix saving of sort, fixes #32757
- Fix printing size, fixes #48224
- Fix float decimal point input #58163

* Thu Aug  8 2002 Alexander Larsson <alexl@redhat.com> 2.0.7-23
- Fix unsigned/signed bug. Closes #60998.
- Update threadbadhack to correctly propagate process time to the main thread.

* Wed Aug  7 2002 Alexander Larsson <alexl@redhat.com> 2.0.7-22
- Don't strip binaries

* Fri Jul 12 2002 Alexander Larsson <alexl@redhat.com> 2.0.7-21
- Remove the X11 subpackage

* Mon Jul  1 2002 Alexander Larsson <alexl@redhat.com> 2.0.7-19
- Added patch that fixes #35174

* Wed Jun 26 2002 Alexander Larsson <alexl@redhat.com> 2.0.7-18
- New thread badhack patch. Fixes a segfault.

* Mon Jun 24 2002 Alexander Larsson <alexl@redhat.com> 2.0.7-16
- New thread badhack. Now enabled by default.

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu Jun 20 2002 Alexander Larsson <alexl@redhat.com> 2.0.7-14
- Added badhack to support hiding threads

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon Apr 15 2002 Bill Nottingham <notting@redhat.com> 2.0.7-12
- add ldconfig in %postun

* Mon Aug 27 2001 Trond Eivind Glomsrod <teg@redhat.com> 2.0.7-11
- Add ncurses-devel as a build dependency (#49562)

* Sat Jul 21 2001 Tim Powers <timp@redhat.com>
- removed applnk entry, one of the things that's cluttering our menus

* Sun Jun 24 2001 Elliot Lee <sopwith@redhat.com>
- Bump release + rebuild.

* Thu Apr  5 2001 Jakub Jelinek <jakub@redhat.com>
- fix AIX style user defined formats (#34833)

* Thu Mar 22 2001 Bill Nottingham <notting@redhat.com>
- add a '-e' to sysctl to ignore errors (#31852)

* Mon Mar  5 2001 Preston Brown <pbrown@redhat.com>
- bigger buffer for reading /proc/stat fixes segfault (#27840)

* Thu Feb  1 2001 Preston Brown <pbrown@redhat.com>
- make sysctl return a value when errors occur (#18820).
- support big UIDs (#22683)

* Mon Jan 22 2001 Helge Deller <hdeller@redhat.com>
- work-around for negative CPU output (Bug #18380)

* Thu Aug 17 2000 Than Ngo <than@redhat.com>
- fix failing in RPM post script (Bug #16226)

* Wed Jul 26 2000 Michael K. Johnson <johnsonm@redhat.com>
- Added Jakub's locale patch

* Fri Jul 14 2000 Michael K. Johnson <johnsonm@redhat.com>
- procps-2.0.7
- integrated all patches except for signames patch, which is broken
  and unnecessary
- See NEWS for changes between 2.0.6 and 2.0.7
- Added patch to correctly install desktop file.  Oops.

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Tue Jul 03 2000 Preston Brown <pbrown@redhat.com>
- larger buffers for reading /proc/stat

* Tue Jun 13 2000 Preston Brown <pbrown@redhat.com>
- FHS paths

* Tue May 30 2000 Preston Brown <pbrown@redhat.com>
- add smp, signal name patches from VA Linux.  Thanks guys.

* Mon May 22 2000 Harald Hoyer <harald@redhat.com>
- added sysctl.conf (5) man page

* Wed May 10 2000 Bill Nottingham <notting@redhat.com>
- fix PAGE_SIZE mismatch on ia64

* Sun May  7 2000 Bill Nottingham <notting@redhat.com>
- rebuild with different optimizations for ia64

* Fri Mar 24 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- rebuild with current ncurses

* Tue Mar  7 2000 Bill Nottingham <notting@redhat.com>
- fix end-of-file behavior in sysctl

* Mon Feb 07 2000 Preston Brown <pbrown@redhat.com>
- wmconfig -> desktop

* Mon Feb  7 2000 Jakub Jelinek <jakub@redhat.com>
- don't try to load System.map (and spit error messages if it does not
  exist) if ps or top are not going to use it, both to speed things up
  and remove the ugly messages when they don't make sense.
- in top, print the possible error messages using standard top SHOWMESSAGE
  (because it will be now printed out when already in terminal mode).

* Thu Feb  3 2000 Matt Wilson <msw@redhat.com>
- added patch to prevent divide by zero on UltraSparc
- gzip man pages

